//+------------------------------------------------------------------+
//|                                                         test.mq4 |
//|                                  Copyright  2008, Jason Muchow. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Jason Muchow."
#property link      ""

extern int equity_lock = 100;
extern int equity_lock_start = 130;
extern int equity_target = 500;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

   string filename = Symbol() + "_equity_watch.txt";
   int f = FileOpen(filename,FILE_WRITE);
   FileWrite(f,"new");
   FileClose(f);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
   string filename = Symbol() + "_equity_watch.txt";
   int f = FileOpen(filename,FILE_WRITE);
   FileWrite(f,"new");
   FileClose(f);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
 
   int i;
   bool dump=false;
   
   double profit = AccountEquity() - AccountBalance();
   
   string filename = Symbol() + "_equity_watch.txt";
   int f = FileOpen(filename,FILE_WRITE|FILE_READ);
   if (f<0) {Print("Can\'t open file, exiting.");return(-1);}
   
   string text = FileReadString(f);
   if (text == "new") {
      if (profit >= equity_lock_start) { text="lock"; }
   }
   if (text == "lock") {
      if (profit <= equity_lock) {dump=true;}
      if (profit >= equity_target) { text="close"; }
   }
   if (text == "close") {
      dump=true;
   }
   
   if (OrdersTotal()>0) {
      for (i=OrdersTotal();i>=1;i--) {
         if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true) {
            if (OrderSymbol() == Symbol()) {
               if (dump) {
                  double price=0;
                  if (OrderType()==OP_BUY) {price=Bid;}else{price=Ask;}
                  OrderClose(OrderTicket(),OrderLots(),price,1,CLR_NONE);
               }
            }
         }
      }
   } else {
      text = "new";
   }
   
   FileSeek(f,0,SEEK_SET);
   FileWrite(f,text);
   FileClose(f);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

